DEFDBL a-z
DECLARE FUNCTION f (x)
DECLARE FUNCTION Iexact(x)
DECLARE SUB gauleg(x1,x2,xgs(),wgs(),n%)

Dim xgs(300), wgs(300)
'
' Sample program to compute the integral of a function f(x)
' between a lower boundary a and an upper boundary b.
'
' The exact form of f(x) is placed in FUNCTION f(x) of this
' program
'
PRINT "P. Hellings: Astrophysics with a PC : SOME NUMERICAL METHODS"
PRINT "-------------------------------"
' Adapted by Kiyoshi Kawabata from the program of Chapter 1
' on May 31, 2008
PRINT "Simpson method for numerical integration"
COLOR 14
PRINT "Example on p.27: Integral of f(x)=exp(-x)+2x from x=2 to 6"
PRINT "Try a=2, b=6 and n=2, 4, 8, 20, 50, and 100 
COLOR 15
PRINT ""
INPUT "lower boundary a : "; a
INPUT "upper boundary b : "; b
INPUT "number of subintervals used (EVEN NUMBER !) :"; n%

'compute number of pairs of subintervals and interval size
 m% = n% / 2
 h = (b - a) / n%
 
'initialize the cycle
  integral = 0
  xlow = a
  flow = f(xlow)
  
'during each loop of following cycle, the contribution of
'two more subintervals is taken into account

FOR i% = 1 TO m%

'    compute other meshpoints of two successive subintervals
'    and their function values

      xmid = xlow + h
      xup = xlow + 2 * h
      
      fmid = f(xmid)
      fup = f(xup)
      
'    compute and add contribution of these two subintervals
      integral = integral + h * (flow + 4 * fmid + fup) / 3

'    prepare for next loop
      xlow = xup
      flow = fup
      
NEXT i%
      CALL gauleg(a,b,xgs(),wgs(),n%)
      sum=0.0
      FOR i%=1 TO n%
      sum=sum+f(xgs(i%))*wgs(i%)
      NEXT i%
  
      sexact=Iexact(b)-Iexact(a)
      erinteg=100*ABS(1.0D0-integral/sexact)
      ersum=100*ABS(1.0D0-sum/sexact)
      
      
PRINT "" 
PRINT "Exact value of integration=";sexact
PRINT "(";n%;"-point formulae)"
PRINT "Simpson method : "; integral;",   Error : ";erinteg;"%" 
PRINT "Gauss-Legendre : "; sum;     ",   Error : ";ersum;"%"

COLOR 14
PRINT ""
PRINT "Type any key to terminate the job!!!"
DO 
LOOP WHILE INKEY$ = ""
END

FUNCTION f (x)
'
'  contains the function that has to be integrated
'
       f = EXP(-x) + 2 * x
       
END FUNCTION   

FUNCTION Iexact(x)
 
 Iexact=-EXP(-x)+x^2

END FUNCTION

SUB gauleg(x1,x2,x(),w(),n%)
' Adapted by Kiyoshi Kawabata from "Numerical Recipes in FORTRAN"
' (W.H. Press, S.A. Teukolsky, W.T. Vetterling, and B.P. Flannery),
' Second Edition, (1992, Cambridge University Press), p.145.

      CONST EPS=3.d-14  ' EPS is the relative precision
'      Given the lower and upper limits of integration x1 and x2, 
'      and given n%, this routine returnsarrays x(1:n%) and w(1:n%) 
'      of length n%, containing the abscissas and weghts of the Gauss-
'      Legendre n%-points qadrature formula.
'      
'      High precision is a good idea for this routine.
      m%=(n%+1)/2       ' The roots are symmetric in the ;interval, so 
      xm=0.5d0*(x2+x1)  ' we only have to find half of them.
      xl=0.5d0*(x2-x1)
      FOR i%=1 TO m%    ' Loop over the desired roots.
        z=cos(3.141592654d0*(i%-.25d0)/(n%+.5d0))
'         Starting with the above approcimation to the ith we enter 
'         the main loop of refinement by Newton's method.        
1:      
          p1=1.d0
          p2=0.d0
          FOR j%=1 TO n%   ' Loop up the recurrence relation to get
            p3=p2          ' the Legendre polynomial evaluated at z.
            p2=p1
            p1=((2.d0*j%-1.d0)*z*p2-(j%-1.d0)*p3)/j%
11:       NEXT j%
'     p1 is now the desired Legendre polynomial. We next compute pp, by
'     a standard relation involving also p2, the polynomial ofone lower
'     order.
          pp=n%*(z*p1-p2)/(z*z-1.d0)
          z1=z
          z=z1-p1/pp                ' Newton's method
        if(abs(z-z1)>EPS) goto 1
        x(i%)=xm-xl*z               ' Scale the root to athe desired interval,
        x(n%+1-i%)=xm+xl*z          ' and put in its symmetric counterpart.  
        w(i%)=2.d0*xl/((1.d0-z*z)*pp*pp)  ' Compute the weight
        w(n%+1-i%)=w(i%)                  ' and its symmetric couterpart.
12:    NEXT i%
      
      END SUB
