DEFSNG a-z

DECLARE FUNCTION datm (y)
DECLARE SUB effes (x, y, u, v, m, k1, k2, tau, fx, fy, fu, fv,_
    fm, s)
Dim ys(5),us(5),vs(5),ms(5),k1s(5),k2s(5),taus(5),Nms$(5)
INPUT "Key in 1 for Fig.3.2, or 0 for manual input:  ", Nkey%

PRINT ""
PRINT "P.Hellings: Astrophysics with a PC : METEOR"
PRINT "-------------------------------"
'  Adapted by Kiyoshi Kawabata from the minimal program of Chapter 3
'  on May 9, 2009
IF Nkey% <> 0 THEN
     LtypeSt%=1
     Ntype%=5
     Nms$(0)=""
     For i%=1 TO Ntype%
        READ ys(i%),us(i%),vs(i%),ms(i%),k1s(i%),k2s(i%),taus(i%),Nms$(i%)
     Next i%  
ELSE
    PRINT "Input of initial conditions and parameters : "
INPUT "Initial height (km)             : ", ys(0)
INPUT "Initial horizontal speed (km/s) : ", us(0)
INPUT "Initial vertical speed (km/s)   : ", vs(0)
INPUT "Initial mass (gram)             : ", ms(0)
INPUT "Parameter K1 : ", k1s(0)
INPUT "Parameter K2  : ", k2s(0)
INPUT "Parameter tau : ", taus(0)
    LtypeSt%=0
    Ntype%=0
    Nms$(0)=""
END IF    
CALL GRAPHSET

FOR Ltype%=LtypeSt% TO Ntype%
'IF Nkey%=1 Then

      y=ys(Ltype%)
      u=us(Ltype%)
      v=vs(Ltype%)
      k1=k1s(Ltype%)
      k2=k2s(Ltype%)
      m=ms(Ltype%)
      tau=taus(Ltype%)
'ELSE   


'ENDIF

' Transform input data x,y,u and v from km to cm
' and make sure that v is negative
y = y * 100000!
x = 0
u = u * 100000!
v = -ABS(v * 100000!)
minit = m
t = 0!
i% = 1
     
     CALL effes(x, y, u, v, m, k1, k2, tau, fx, fy, fu, fv, fm, s)
  ' computations of the apparent magnitude
    e = -.5 * tau * fm * s ^ 2
    mag = 5 * LOG(y) / LOG(10) - 2.5 * LOG(e) / LOG(10) - 8.795  
    mabmin=mag
    PSET (t,mag)

DO   ' this is the main loop of the program

' next 3 nested IF-blocks select the time step dt
    IF m > .8 * minit THEN
        dt = .1
    ELSE
        IF m > .5 * minit THEN
            dt = .05
        ELSE
            IF m > .35 * minit THEN
                dt = .02
            ELSE
                dt = .01
            END IF
        END IF
    END IF
    
    t = t + dt

' next line computes right hand sides of the 5 differential
' equations (state i)
  CALL effes(x, y, u, v, m, k1, k2, tau, fx, fy, fu, fv, fm, s)
    
' next 5 instructions compute the predicted state i+1
    x1 = x + dt * fx
    y1 = y + dt * fy
    u1 = u + dt * fu
    v1 = v + dt * fv
    m1 = m + dt * fm
    rho1 = datm(y1)
    s1 = SQR(u1 * u1 + v1 * v1)

' next line computes right hand sides of the 5 differential
' equations (state Ei+1)
    CALL effes(x1, y1, u1, v1, m1, k1, k2, tau, fx1, fy1, _
    fu1, fv1, fm1, s1)

    ' next 5 instructions compute the corrected state at i+1
    x = x + .5 * dt * (fx + fx1)
    y = y + .5 * dt * (fy + fy1)
    u = u + .5 * dt * (fu + fu1)
    v = v + .5 * dt * (fv + fv1)
    m = m + .5 * dt * (fm + fm1)

' computations of the apparent magnitude
    e = -.5 * tau * fm1 * s1 ^ 2
    mag = 5 * LOG(y) / LOG(10) - 2.5 * LOG(e) / LOG(10) - 8.795
' Results are shown on screen
   IF y > 0 THEN
       LINE -(t,mag), Ltype%
   __SLEEP   1                
       IF mag < magmin THEN 
           magmin=mag
       END IF    
   ELSE
      PRINT ""
      PRINT "Meteoroid has reached the ground"
      m = 0
   END IF
    i% = i% + 1

LOOP UNTIL m < minit * .01           'end of main loop

' Attach the label to each curve of Fig. 3.2
      IX%=PMAP(t,0)/8+1
      IY%=PMAP(mag,1)/16+1
      LOCATE (IY%,IX%)
      PRINT Nms$(Ltype%)
'     SLEEP 1
NEXT Ltype%
LOCATE (28,5)
COLOR 14
PRINT "Press any key to terminate this job"
DO
LOOP WHILE INKEY$ = ""

'           y     u      v     m    k1    k2     tau  Type
101: DATA 160.0, 20.0, -40.0, 1.00, 1.0, 1.E-11, 0.02,  A
102: DATA 160.0, 20.0, -40.0, 0.01, 1.0, 1.E-11, 0.02,  B
103: DATA 160.0, 20.0, -60.0, 1.00, 1.0, 1.E-11, 0.02,  C
104: DATA 160.0, 20.0, -40.0, 1.00, 1.0, 5.E-11, 0.02,  D
105: DATA 140.0, 10.0, -30.0, 0.01, 0.8, 1.E-11, 0.01,  E

END

FUNCTION datm (y)
'
'    computes the atmospheric density at height y(cm)
'
     datm = EXP(-6.65125 - 1.39813E-06 * y)
END FUNCTION

SUB effes (x, y, u, v, m, k1, k2, tau, fx, fy, fu, fv, fm, s)
'
'  computes fx, fy, fu, fv, fm and s (the speed) 
'  for a position (x,y), velocity (u,v) and mass(m) and 
'  with parameters k1, k2 and tau   

     fx = u
     fy = v
     s = SQR(u ^ 2 + v ^ 2)
     rho = datm(y)
     fu = -k1 * rho * s * u * EXP(-1 / 3 * LOG(m))
     fv = -k1 * rho * s * v * EXP(-1 / 3 * LOG(m)) - 980
     fm = -k2 * rho * s ^ 3 * EXP(2 / 3 * LOG(m))
END SUB

SUB GRAPHSET
    SCREEN 18,2
'    SCREENSET 1,0
    WINDOW SCREEN (-0.4,-8)-(2.4,14)
 
    VIEW (50,50)-(690,415)
' Draw t and mb axes    
    LINE (-0,12)-(2.2,12),5
    LINE (0,12)-(0,-6),5
' Draw  tick marks on the axes
        y=0.15
    For i%=2 To 11
        x=0.2*(i%-1)
        LINE (x,12)-(x,12-y),5
        
    NEXT i%  
        LINE (1,12)-(1,12-0.4),5
        LINE (2,12)-(2,12-0.4),5
        x=0.05
    FOR i%=1 To 4
        y=-5+5*(i%-1)
        LINE (0,y)-(x,y), 5
    NEXT i%    
    LOCATE (24,78)  
    PRINT "t"
    LOCATE (26,18)  
    PRINT "0"
    LOCATE (26,44)  
    PRINT "1"
    LOCATE (26,70)  
    PRINT "2"    
    LOCATE (4,16)
    PRINT "m_b"
    LOCATE (7,14)
    PRINT "-5"
    LOCATE (12,14)
    PRINT " 0"
    LOCATE (17,14)
    PRINT " 5"
    LOCATE (22,14)
    PRINT "10"
END SUB