DEFDBL a-z
DECLARE SUB effes (x, y, u, v, mu, fu, fv)
DECLARE SUB LAGPS(mu,xlps(),ylps()) 

CLS
Dim mus(10),xs(10),ys(10),us(10),vs(10),dts(10)
Dim xlps(4),ylps(4)    
INPUT "Key in 1 for Figs. 4.5 - 4.9, or 0 for manual input:  ", Nkey%

PRINT " "
PRINT " "
PRINT "P.Hellings: Astrophysics with a PC : RESTRICTED THREEBODY PROBLEM"
PRINT "-----------------------------------------------------"
PRINT " "

'  Adapted by Kiyoshi Kawabata from the minimal program of Chapter 4
'  on May 10, 2009
IF Nkey%=1 THEN    
     LtypeSt%=1
     Ntype%=8
     For i%=1 TO Ntype%
        READ mus(i%),xs(i%),ys(i%),us(i%),vs(i%),dts(i%)
        CALL LAGPS(mus(i%),xlps(),ylps())
        PRINT "Lagrangian points for (";i%;")mu=";mus(i%) 
        FOR j%=1 TO 4
        PRINT "     L";j%;" : x=";xlps(j%);"  y=";ylps(j%)    
        NEXT j%
     Next i%  
ELSE
PRINT "Input of initial conditions and parameters : ');"
PRINT ""
INPUT "Mass parameter  mu        : ", mu
INPUT "Initial conditions : x(0) : ", x
INPUT "                     y(0) : ", y
INPUT "                     u(0) : ", u
INPUT "                     v(0) : ", v
INPUT "Time step                 : ", dt
     LtypeSt%=0
     Ntype%=0
     mus(0)=mu : xs(0)=x : ys(0)=y : us(0)=u : vs(0)=v : dts(0)=dt
     CALL LAGPS(mus(0),xlps(),ylps())
     PRINT "Lagrangian points for (0)mu=";mus(0) 
      FOR j%=1 TO 4
        PRINT "     L";j%;" : x=";xlps(j%);"  y=";ylps(j%)    
      NEXT j%
END IF
CLS

FOR Ltype%=LtypeSt% TO Ntype%
 mu=mus(Ltype%): x=xs(Ltype%): y=ys(Ltype%): u=us(Ltype%): v=vs(Ltype%)
 dt=dts(Ltype%)
  
  CALL GRAPHSET(Ltype%,mu)
    LOCATE (2,4*((-1)^Ltype%+2))
      PRINT "(";Ltype%;")
t = dts(Ltype%)
n% = 20
ni% = 1
PSET(x,y)
 DO       ' Main cycle computes blocks of 20 iterations and then 


' next FOR-cycle computes 20 new iterations
 100:   FOR i% = 1 TO n%

' next block computes half step values of Cauchy method
        x1 = x + .5 * dt * u
        y1 = y + .5 * dt * v
        CALL effes(x, y, u, v, mu, fu, fv)
        u1 = u + .5 * dt * fu
        v1 = v + .5 * dt * fv

' next block computes new state i+1 of Cauchy method
        x = x + dt * u1
        y = y + dt * v1
        CALL effes(x1, y1, u1, v1, mu, fu, fv)
        u = u + dt * fu
        v = v + dt * fv

        t = t + dt
        ni% = ni% + 1
        
        LINE -(x,y), 2
       __SLEEP 1 
    NEXT i%

'Ask user whether to continue or not
   LOCATE (3,2)
  PRINT "Continue (y/n/s) ?"
      DO
           ch$ = LCASE$(INKEY$)
      LOOP UNTIL (ch$ = "y") OR (ch$ = "n") OR (ch$ = "s")
      
 '  PRINT " "
    IF ch$="n" GOTO 150
    IF ch$="s" GOTO 300
    GOTO 100
    LOOP while  ch$ = "" 
  150:  IF Ltype% MOD 2=0 THEN
           COLOR 14  
           PRINT "Any key to proceed to the next" 
           COLOR 15
           DO
           LOOP WHILE INKEY$=""    
        END IF
        
      
 NEXT Ltype%
 COLOR 13
 PRINT "Any key to terminate this job" 
           COLOR 15
           DO
           LOOP WHILE INKEY$=""    

' The initial conditions for the orbits A and B of Trojan asteroids
    101: DATA 0.000953875,-0.509046125, 0.883345912,  0.0258975212, _
              0.0149272418,0.4 
    102: DATA 0.000953875,-0.524046125, 0.909326674,  0.0646761399, _
              0.0367068277,0.2
' The Earth-Moon system: closed orbits around L4 or L5              
    103: DATA 0.0121396054,-0.4978603946,0.8833459119, 0.0265752203,_ 
              0.0146709149,0.2
    104: DATA 0.0121396054,-0.5128603946,0.9093266740, 0.0682722747,_
              0.0334034039,0.2
' Ideal orbits Hilda and Thule without libration              
    105: DATA 0.000953875,-0.647717531, 0.0,          0.0,         _
             -0.6828143998,0.02
    106: DATA 0.000953875,-0.7997634829,-0.0,         0.0,         _
             -0.3334548184, 0.05        
' Orbit of HIlda with a libration of 40 degrees.             
    107: DATA 0.000953875,-0.4952265404,-0.4163448036,0.4389046359,_
             -0.5230661767,0.05 
 ' The orbit of Pluto relative to the Sun and Neptune            
    108: DATA 0.0000525,-0.6073955952,-0.7774968265,0.1083342234,_
             -0.084639971594,0.05
300: END

SUB effes (x, y, u, v, mu, fu, fv)
'
' computes the right hand sides (fu and fv) of the differential
' equations for the components of the velocity for input values
' of x,y,u,v and mu 
'
     r1 = SQR((x - mu) * (x - mu) + y * y)
     r2 = SQR((x + 1 - mu) * (x + 1 - mu) + y * y)
     fu = -(1 - mu) * (x - mu) / r1 ^ 3 - mu * (x + 1 - mu) _
     / r2 ^ 3 + x + 2 * v
     fv = -(1 - mu) * y / r1 ^ 3 - mu * y / r2 ^ 3 + y - 2 * u
     r1 = SQR((x - mu) * (x - mu) + y * y)
     r2 = SQR((x + 1 - mu) * (x + 1 - mu) + y * y)
     fu = -(1 - mu) * (x - mu) / r1 ^ 3 - mu * (x + 1 - mu) _
     / r2 ^ 3 + x + 2 * v
     fv = -(1 - mu) * y / r1 ^ 3 - mu * y / r2 ^ 3 + y - 2 * u
END SUB

SUB GRAPHSET(Ltype%,mu)
  xp2=mu-1
  xp1=mu
  xL4=mu-0.5
  yL4=0.8660254
IF Ltype%=0 THEN
    SCREEN 18,2
    __SCREENSET 1,0
    WINDOW  (-2.5,2.5)-(2.5,-2.5)
    VIEW (100,10)-(600,600)
'       Draw X and Y axes    
    LINE (0.0,-2)-(0.0,2),5
    LINE (-2,0.0)-(2,0.0),5
    LINE (xp2,0)-(xp2,0.1),5
    CIRCLE(xp1,0),0.03,4
    CIRCLE(xp2,0),0.03,4
    CIRCLE(xL4,yL4),0.01,4 
    CIRCLE(xL4,-yL4),0.01,4
' Orbits A and B Trojan asteroids:  
ELSEIF Ltype%<= 2 THEN
    IF Ltype%=1 THEN   
        SCREEN 18,2
        __SCREENSET 1,0
        WINDOW  (-1.5,2.5)-(1.5,-0.5)
        VIEW (100,10)-(600,600)
    ENDIF
    CIRCLE(xp1,0),0.03,4
    CIRCLE(xp2,0),0.03,4
    CIRCLE(xL4,yL4),0.01,4
    CIRCLE(xL4,-yL4),0.01,4
'       Draw X and Y axes    
    LINE (0.0,0)-(0.0,1.4),5
    LINE (-1.2,0.0)-(1.2,0.0),5
    LINE (xp2,0)-(xp2,0.1),5
    LOCATE (26,23)
      PRINT "J"
    LOCATE (26,44)
      PRINT "S"
' Cases C and D:   Periodic orbits aroud L4 and L5     
ELSEIF Ltype%<= 4 THEN
    IF Ltype%=3 THEN    
       SCREEN 18,2
       __SCREENSET 1,0 
       WINDOW  (-1.5,1.5)-(1.5,-1.5)
       VIEW (100,10)-(600,600)
    ENDIF   
'       Draw X and Y axes    
    LINE (0.0,-1.4)-(0.0,1.4),5
    LINE (-1.2,0.0)-(1.2,0.0),5
    LINE (xp2,0)-(xp2,0.1),5
    CIRCLE(xp1,0),0.03,4
    CIRCLE(xp2,0),0.03,4
    CIRCLE(xL4,yL4),0.01,4
    CIRCLE(xL4,-yL4),0.01,4
    LOCATE (14,24)
       PRINT "M"
    LOCATE (14,46)
       PRINT "E"
' Ideal orbits of Hilda and Thule, without libration        
ELSEIF Ltype%<=6 THEN
    IF Ltype%=5 THEN   
       SCREEN 18,2
       __SCREENSET 1,0 
       WINDOW  (-1.5,1.5)-(1.5,-1.5)
       VIEW (100,10)-(600,600)
    ENDIF   
' Draw X and Y axes    
    LINE (0.0,-1.4)-(0.0,1.4),5
    LINE (-1.2,0.0)-(1.2,0.0),5
    LINE (xp2,0)-(xp2,0.1),5
    CIRCLE(xp1,0),0.03,4
    CIRCLE(xp2,0),0.03,4
    CIRCLE(xL4,yL4),0.01,4
    CIRCLE(xL4,-yL4),0.01,4
    LOCATE (14,24)
       PRINT "J"
    LOCATE (14,46)
       PRINT "S"    
' The orbit of Hilda with a libration of 40 degrees
ELSEIF Ltype%=7 THEN
    SCREEN 18,2
    __SCREENSET 1,0
    WINDOW  (-1.5,1.5)-(1.5,-1.5)
    VIEW (100,10)-(600,600)
' Draw X and Y axes    
    LINE (0.0,-1.4)-(0.0,2),5
    LINE (-2,0.0)-(2,0.0),5
    LINE (xp2,0)-(xp2,0.1),5
    LINE (-xp2,0)-(-xp2,0.1),5
    CIRCLE(xp1,0),0.03,4
    CIRCLE(xp2,0),0.03,4
    CIRCLE(xL4,yL4),0.01,4
    CIRCLE(xL4,-yL4),0.01,4
        LOCATE (14,24)
        PRINT "J"
        LOCATE (14,46)
        PRINT "S"    
' Fig. 4.8 and Fig. 4.9: The orbit of Pluto relative to the Sun and 
'                        Neptune system
ELSE  
    SCREEN 18,2
    __SCREENSET 1,0
    WINDOW  (-2,2)-(2,-2)
    VIEW (100,10)-(600,600)
' Draw X and Y axes    
    LINE (0.0,-1.8)-(0.0,2),5
    LINE (-2,0.0)-(2,0.0),5
    LINE (xp2,0)-(xp2,0.1),5
    LINE (-xp2,0)-(-xp2,0.1),5
    CIRCLE(xp1,0),0.03,4
    CIRCLE(xp2,0),0.03,4
    CIRCLE(xL4,yL4),0.01,4
    CIRCLE(xL4,-yL4),0.01,4
        LOCATE (17,29)
        PRINT "N"
        LOCATE (17,46)
        PRINT "S"
ENDIF    
END SUB  
  
SUB LAGPS(mu,xlps(),ylps())
' Find the locations of Lagrange points
    mum1=1-mu
  FOR I%=1 TO 3
    IF I%=1 THEN
       x= 0.0 : h1=-1.0 : h2=1.0
    ELSEIF I%=2 THEN
       x=-1.0 : h1=-1.0 : h2=-1.0
    ELSE
       x= 1.0 : h1= 1.0 : h2=1.0
    ENDIF    
      
       c1=h1*mum1
       c2=h2*mu
   
      FOR J%=1 TO 100    
       sa=x-mu
       sb=x+mum1
       xnw=x-(x-c1/sa^2-c2/sb^2)/(2*(c1/sa^3+c2/sb^3)+1.0)
       IF(ABS(1.0-xnw/x)< 1.E-6) GOTO 200
       x=xnw
      NEXT J%
      PRINT "Warning: not enough number of iterations!!!"
 200: xlps(I%)=xnw
      ylps(I%)=0.0    
  NEXT I%
      xlps(4)=mu-0.5
      ylps(4)=0.8660254
      PRINT "No. of iterations=";J%
END SUB