DEFDBL a-z
CONST eps = .01
Dim ps(2),aas(2),mv1s(2),mv2s(2),bc1s(2),bc2s(2)
CLS
PRINT " "
PRINT " "
PRINT "P.Hellings: Astrophysics with a PC : DYNAMICAL PARALLAX"
PRINT "-------------------------------------------"
PRINT " "
' Adapted by Kiyoshi Kawabata from the program of Chapter 6
' on May 22, 2008
INPUT "0 for a new model, 1 for Eta Cas and 2 for Alpha Cen"; _
       Nkey%
IF Nkey%=0 THEN
PRINT " "
PRINT "Input of the observed data :"
INPUT "Orbital period (years)                    : ", p
INPUT "Apparent distance (arc seconds)           : ", a
INPUT "Apparent magnitude of first component     : ", mv1
INPUT "Apparent magnitude of second component    : ", mv2
INPUT "Bolometric correction of first component  : ", bc1
INPUT "Bolometric correction of second component : ", bc2
      ps(0)=p: aas(0)=a: mv1s(0)=mv1: mv2s(0)=mv2
      bc1s(0)=bc1: bc2s(0)=bc2
      ELSE 
      FOR i%=1 TO 2
      READ ps(i%),aas(i%),mv1s(i%),mv2s(i%),bc1s(i%),bc2s(i%)
      NEXT i%
ENDIF   
     
      p=ps(Nkey%): a=aas(Nkey%): mv1=mv1s(Nkey%): mv2=mv2s(Nkey%)
      bc1=bc1s(Nkey%): bc2=bc2s(Nkey%)
      PRINT ""
      PRINT USING "P=###.# (yrs), a=###.## (arcsec), " _ &
      "mv1=##.#, mv2=##.#, BC1=##.## , BC2=##.##"; _
      p; a; mv1; mv2; bc1; bc2
PRINT " "
PRINT _
"  i       m1        m2       dist      par       Mb1      Mb2"

' select starting values for the two masses

m1 = 1!
m2 = 1!
stopcrit% = 0
i% = 1
DO    'Main cycle that stops when the two masses have converged
   par = a / p ^ (2 / 3) / (m1 + m2) ^ (1 / 3)
   mabs1 = mv1 + 5 + 5 * LOG(par) / LOG(10!)
   mabs2 = mv2 + 5 + 5 * LOG(par) / LOG(10!)
   mb1 = mabs1 - bc1
   mb2 = mabs2 - bc2
   m11 = 10 ^ (.58 - .112 * mb1) ' new approximation 
                                 ' of first mass
   m22 = 10 ^ (.58 - .112 * mb2) ' new approximation 
                                 ' of second mass
   dis = 1 / par * 3.26          ' new approximation
                                 ' of the distance

' show iterations on screen
   PRINT USING "### ######.## ######.## #####.### ######.##" &_
   " ######.# ######.#"; i%; m1; m2; par; dis; mb1; mb2
    
' check convergence (if yes, stopcrit% becomes 1)    
   IF (ABS(m1 - m11) < eps) AND (ABS(m2 - m22) < eps) THEN
        stopcrit% = 1
   ELSE
        m1 = m11
        m2 = m22
        i% = i% + 1
   END IF
LOOP UNTIL (stopcrit% = 1) OR (i% > 15)

' show final results on screen
IF i% > 15 THEN
   PRINT "Method does not converge for your input"
ELSE
   PRINT USING "Final results : mass of 1st component : " &_
                                "###.##"; m11
   PRINT USING "                mass of 2nd component : " &_
                                "###.##"; m22
   PRINT USING "                distance in light yrs : " &_
                                "###.##"; dis
END IF
COLOR 14
PRINT "Press any key to stop the program"
DO
LOOP WHILE INKEY$ = ""
'  Input data for Eta Cas and Alpha Cen dynamical parallaxes
'          P,    a,    mv1, mv2,  bc1,  bc2   
     DATA 526, 12.21,  3.7, 7.4, 0.03, 0.67
     DATA 78.8, 17.6 , 0.3, 1.7, 0.06, 0.30
    
END
