DEFDBL a-z
DECLARE FUNCTION lg10 (x)
DECLARE FUNCTION temp (mu, p, d)
DECLARE FUNCTION e (d, t)
DECLARE SUB poly (n, x, f, h, pc, dc, rn, p, d, mr, r)
DECLARE SUB graphset(mtot,eelogmax,llogmax)
DECLARE SUB graphset2(Xmax,Ymax) 
DIM   xxs(501),fs(501),hs(501),plogs(501),dlogs(501), _
      rs(501),ms(501),tlogs(501),eelogs(501),llogs(501)
 
COMMON SHARED pi, g, a, rgas, xx, yy, zz, mu, m0, r0, l0

' declare a number of constants in the program
pi = 3.1415926536#
g = 6.673E-08
a = 7.56464E-15
rgas = 8.314E+07
xx = .7
yy = .27
zz = .03
mu = .618238
m0 = 2E+33
r0 = 6.96E+10
l0 = 3.83E+33

CLS
PRINT " "
PRINT "P.Hellings: Astrophysics with a PC: STELLAR MODEL"
PRINT "-------------------------------------"
PRINT " "
' Adapted by Kiyoshi Kawabata from the program of Chapter 8
' on May 22, 2008

INPUT "0 for a new model, and 1 for Tables 8-1 and 8-2"; Nkey%
IF Nkey%=0 THEN
PRINT " "
INPUT _
"Input parameter : Approximation; of; total; mass(2 - 15) : ", _
                   mtot    
ELSE 
PRINT " "
                   mtot=10.0
ENDIF      

' show heading of main table
PRINT " i  Mr/Mo  log(p)  log(T)  log(d)  r/ro   " &_
      "log(E)  log(L)   x      f       h"

w = lg10(mtot)

' central values of temperature and density
tc = 7.23937 + .2724354# * w - .0401771# * w * w
tc = 10 ^ tc
dc = 2.27899 - 1.658707 * w + .29329095# * w * w
dc = 10 ^ dc

' compute the value of the fitmass
IF mtot < 4 THEN
    ffit = 9
ELSE
    IF mtot < 10 THEN
        ffit = 19.58794 - 17.58794 * w
    ELSE
        ffit = 2
    END IF
END IF

' compute other central quantities
pgc = rgas * dc * tc / mu
prc = 1 / 3 * a * tc ^ 4
ptc = pgc + prc
betac = pgc / ptc
beta = 1 - 2 / 3 * (1 - betac)
fb = (8 - 6 * beta) / (32 - 24 * beta - 3 * beta ^ 2)
n = (1 - fb) / fb
rn = SQR((n + 1) * ptc / 4 / pi / g / dc / dc)
eec = e(dc, tc)

i% = 0
x = 0
f = 1
h = 0
m = 0
r = 0
l =10
CALL poly(n, x, f, h, ptc, dc, rn, p, d, m, r)
  ms(i%)=m / m0
  plogs(i%)=lg10(p): tlogs(i%)=lg10(tc): dlogs(i%)=lg10(d)
  rs(i%)=r/r0: eelogs(i%)=lg10(eec): llogs(i%)=lg10(l / 10)
  xxs(i%)=x: fs(i%)=f: hs(i%)=h: 
 
'print first line of table (central values)
PRINT USING "## ##.### ###.### ###.### ###.#### " &_
    "##.### ##.### ###.### ##.### ##.### ###.###"; _
    i%; ms(i%); plogs(i%); tlogs(i%); dlogs(i%);_
            rs(i%); eelogs(i%); llogs(i%); x; f; h
             
' compute and show first step
i% = 1
l = 0
dx = .1
x = dx
f = 1 - 1 / 6 * dx ^ 2 + n / 120 * dx ^ 4
h = -1 / 3 * dx + n / 30 * dx ^ 3
CALL poly(n, x, f, h, ptc, dc, rn, p, d, m, r)
'  PRINT x, f, h, lg10(p), lg10(d), rn

t = temp(mu, p, d)
ee = e(d, t)
dr = dx * rn
  l = 4 / 3 * pi * dc * eec * dr ^ 3
  ms(i%)=m / m0
  plogs(i%)=lg10(p): tlogs(i%)=lg10(t): dlogs(i%)=lg10(d)
  rs(i%)=r/r0: eelogs(i%)=lg10(ee): llogs(i%)=lg10(l / l0)
  xxs(i%)=x: fs(i%)=f: hs(i%)=h: 

    PRINT USING "## ##.### ###.### ###.### ###.#### " &_
    "##.### ##.### ###.### ##.### ##.### ###.###"; _
       i%; ms(i%); plogs(i%); tlogs(i%); dlogs(i%);_
           rs(i%); eelogs(i%); llogs(i%); x; f; h
 
 ' start of main cycle
i% = 2
FOR zone% = 1 TO 2      ' zone% = 1 during convective region
                        ' zone% = 2 during radiative region
    stp% = 0
    DO
       flast = f  'Save previous value of polytrope variable 
'                   in flast
       x12 = x + .5 * dx
       f12 = f + .5 * dx * h

'       check whether f12 is still positive
        IF f12 > 0 THEN
            h12 = h + .5 * dx * (-f ^ n - 2 * h / x)
            p12 = ptc * f12 ^ (n + 1)
            d12 = dc * f12 ^ n
            t12 = temp(mu, p12, d12)

'           compute energy production when in convec- 
'            tive zone
            IF zone% = 1 THEN ee12 = e(d12, t12)
            x = x + dx
            f = f + dx * h12

'           check whether f is still positive
            IF f > 0 THEN
                h = h + dx * (-f12 ^ n - 2 * h12 / x12)
                p = ptc * f ^ (n + 1)
                d = dc * f ^ n
                m = -4 * pi * dc * rn ^ 3 * x ^ 2 * h
                r = rn * x
                t = temp(mu, p, d)

'               compute new value of luminosity when in con- 
'               vective zone
                IF zone% = 1 THEN
                    l = l + 4 * pi * d12 * dx * ee12 *  _
                        rn ^ 3 * x12 ^ 2
                END IF

'              compute energy production of new state when 
'               in convective zone. In radiative zone, 
'               ee is put to 1 so that log(ee) becomes 0
                IF zone% = 1 THEN
                    ee = e(d, t)
                ELSE
                    ee = 1
                END IF

'             show results of layer  i+1  on screen
       ms(i%)=m / m0
       plogs(i%)=lg10(p): tlogs(i%)=lg10(t): dlogs(i%)=lg10(d)
       rs(i%)=r/r0: eelogs(i%)=lg10(ee): llogs(i%)=lg10(l / l0)
       xxs(i%)=x: fs(i%)=f: hs(i%)=h: 
      
             PRINT USING "## ##.### ###.### ###.### ###.#### " &_
             "##.### ##.### ###.### ##.### ##.### ###.###"; _
               i%; ms(i%); plogs(i%); tlogs(i%); dlogs(i%);_
               rs(i%); eelogs(i%); llogs(i%); x; f; h            
               Nlay%=i%
               i% = i% + 1
            ELSE
               surface% = 1     'surface has been reached
            END IF
        ELSE
            surface% = 1         'surface has been reached
        END IF

'    check if in convective zone
     IF zone% = 1 THEN
         test = 1.339944E+09 * p / m * l / t ^ 4 / fb

'        check if boundary of convective zone is reached
          IF test < 1 THEN
           PRINT "Boundary of convective core is reached." &_
                 " Press any key"
           DO
           LOOP WHILE INKEY$ = ""

'         compute fitting parameters
           f = ffit
           ptc = p / ffit ^ 4
           dc = d / ffit ^ 3
           rn = SQR(ptc / pi / g / dc ^ 2)
           x = r / rn
           h = -m / 4 / pi / dc / rn ^ 3 / x ^ 2
           n = 3
           dx = .04
           stp% = 1
           surface% = 0

'        show fitting parameters
            PRINT " "
            PRINT "---------- Fitting parameters ----------"
            PRINT "New centr.press.   : "; ptc
            PRINT "New centr.densiity : "; dc
            PRINT "xfit               : "; x
            PRINT "ffit               : "; ffit
            PRINT "hfit               : "; h
            PRINT "new rn             : "; rn
            PRINT " "
            PRINT "Press any key to continue"
            DO
            LOOP WHILE INKEY$ = ""
            PRINT " "
        END IF

'    next ELSE is entered when in radiative zone
       ELSE
          dx = 1.1 * dx

'       check if surface is reached
         IF surface% = 1 THEN

'         compute exact location of surface and surface data
              stp% = 1
              xs = x - flast / h
              mt = m + .5 * pi * d * rn ^ 3 * (x + xs) ^ 2
              rad = r + rn * (xs - x)
              logteff = 3.7613 + .25 * lg10(l / l0)    _
                       - .5 * lg10(rad / r0)
              PRINT "Press any key to continue"
              DO
              LOOP WHILE INKEY$ = ""
              PRINT " "

'            print surface data
              PRINT "----------------------- surface data " &_
                    "----------------------"
              PRINT USING "Mass (in Mo)         : ####.##"; _
                           mt / m0
              PRINT USING "radius(Ro)           : ####.##"; _
                           rad / r0
              PRINT USING "Luminosity (log(L/Lo): ####.##"; _
                           lg10(l / l0)
              PRINT USING "Effect.temp.(log)    : ####.##"; _
                           logteff

           END IF
       END IF
       LOOP UNTIL stp% = 1
   NEXT zone%
   PRINT "Nlay%=";Nlay%
    PRINT ""
 LOCATE (25,1)
 COLOR 14: PRINT "Press any key to proceed to a Fig. 8.2-like diagram"
 COLOR 7
 DO
 LOOP WHILE INKEY$ = ""
 CALL graphset(mtot,eelogs(0),llogs(Nlay%)) 
 ' (1) M vs. log E(x)
 PSET (ms(0),eelogs(0))
 FOR i%=1 TO Nlay%
     LINE -(ms(i%),eelogs(i%)),2
 NEXT i%   
     Nmid%=Nlay%*0.3
     IX%=PMAP(ms(Nmid%),0)/8+6
     IY%=PMAP(eelogs(Nmid%),1)/16+3
     LOCATE (IY%,IX%)
     PRINT "log E"     
    
 ' (2) M vs. Log L
 PSET (ms(0),llogs(0))
 FOR i%=1 TO Nlay%
     LINE -(ms(i%),llogs(i%)), 3
 NEXT i%
     Nmid%=Nlay%*0.7
     IX%=PMAP(ms(Nmid%),0)/8+6
     IY%=PMAP(llogs(Nmid%),1)/16+3
     LOCATE (IY%,IX%)
     PRINT "log L/L0"   
     
    COLOR 14 
    LOCATE (25,30) 
    PRINT "Press any key to proceed to a model plot"
  __SLEEP
  
     Ymax=ABS(plogs(Nlay%)-plogs(0))
     IF ABS(tlogs(Nlay%)-tlogs(0)) > Ymax THEN 
         Ymax=ABS(tlogs(Nlay%)-tlogs(0))
     ELSEIF ABS(dlogs(Nlay%)-dlogs(0)) > Ymax THEN
         Ymax=ABS(dlogs(Nlay%)-dlogs(0))
     ELSEIF rs(Nlay%) > Ymax THEN
         Ymax=rs(Nlay%)
     ENDIF
     Xmax=1.2*mtot
     Ymax=1.2*Ymax
CALL graphset2(Xmax,Ymax)
' (3) M vs. log P/Pc
 PSET (ms(0),0)
 FOR i%=1 TO Nlay%
     LINE -(ms(i%),plogs(i%)-plogs(0)),2
 NEXT i%   
     Nmid%=Nlay%*0.7
     IX%=PMAP(ms(Nmid%),0)/8-5
     IY%=PMAP(plogs(Nmid%)-plogs(0),1)/16+3
     LOCATE (IY%,IX%)
     PRINT "log P/Pc"
     COLOR 5
     LOCATE (10,15)
     PRINT USING "log Pc=##.###";plogs(0)
     COLOR 15
' (4) M vs. log T/Tc
 PSET (ms(0),0)
 FOR i%=1 TO Nlay%
     LINE -(ms(i%),tlogs(i%)-tlogs(1)),3
 NEXT i%   
     Nmid%=Nlay%*0.8
     IX%=PMAP(ms(Nmid%),0)/8+10
     IY%=PMAP(tlogs(Nmid%)-tlogs(1),1)/16+3
     LOCATE (IY%,IX%)
     PRINT "log T/Tc"  
     COLOR 5
     LOCATE (11,15)
     PRINT USING "log Tc=##.###";tlogs(0)
     COLOR 15
 ' (5) M vs. log d/dc
 PSET (ms(0),0)
 FOR i%=1 TO Nlay%
     LINE -(ms(i%),dlogs(i%)-dlogs(1)),4
 NEXT i%   
     Nmid%=Nlay%*0.8
     IX%=PMAP(ms(Nmid%),0)/8+10
     IY%=PMAP(dlogs(Nmid%)-dlogs(1),1)/16+8
     LOCATE (IY%,IX%)
     PRINT "log d/dc"    
     COLOR 5
     LOCATE (12,15)
     PRINT USING "log dc=##.###";dlogs(0)
     COLOR 15
' (6) M vs. r-Intlog d/dc
     Yoff%=Int(Ymax)
     PSET (ms(0),-Yoff%)
 FOR i%=1 TO Nlay%
     LINE -(ms(i%),rs(i%)-Yoff%),1
 NEXT i%   
     Nmid%=Nlay%*0.3
     IX%=PMAP(ms(Nmid%),0)/8+10
     IY%=PMAP(rs(Nmid%)-Yoff%,1)/16
     
     LOCATE (IY%,IX%)
     PRINT USING "r-##";Yoff%  
    COLOR 14 
    LOCATE (30,30) 
    PRINT "Press any key to terminate this job"  
__SLEEP  
END

FUNCTION e (d, t)
'
'  computes the energy production for given density d 
'  and temperature t
'
     tt = EXP(1 / 3 * LOG(t / 1E+09))
     p1 = 1 + tt * (.133 + tt * (1.09 + tt * .938))
     p2 = 1 + tt * (.027 + tt * (-.788 + tt * (-.149 + tt  _
 * (.261 + tt * .127)))) 
     e1 = 23760! / tt ^ 2 * p1 * EXP(-3.38 / tt)
     e2 = 8.6665E+25 / tt ^ 2 * p2 * EXP(-15.228 / tt   _
        - tt ^ 6 / 9.5481)
     e = d * (xx ^ 2 * e1 + .02 * xx * e2)
END FUNCTION

FUNCTION lg10 (x)
'
'  computes the base 10 logarithm of x 
'  using the natural logarithm LOG
'
     lg10 = LOG(x) / LOG(10!)
END FUNCTION

SUB poly (n, x, f, h, pc, dc, rn, p, d, mr, r)
'
' computes pressure, density, mass and distance to the center 
' starting from the polytrope results (x,f and h) and
' parameters n, pc and dc
'
     p = pc * f ^ (n + 1)
     d = dc * f ^ n
     mr = -4 * pi * dc * rn ^ 3 * x ^ 2 * h
     r = rn * x
END SUB

FUNCTION temp (mu, p, d)
'
' solve the equation of state to compute the temperature from 
' the pressure, density and mean molecular weight
'
     tt = mu * p / rgas / d
     FOR i% = 1 TO 10
         tt = mu / rgas / d * (p - 1 / 3 * a * tt ^ 4)
     NEXT i%
     temp = tt
END FUNCTION

SUB GRAPHSET(mtot,eelogmax,llogmax)
        SCREEN 18,2
        __SCREENSET 1,0
        
        WINDOW  (-0.1,5)-(1.2*mtot, -0.1)
        VIEW    (20,20)-(650,450)
    Nx%=1.1*mtot
    IF llogmax > eelogma THEN 
        Ny%=1.1*llogmax+0.5
    ELSE  
        Ny%=1.1*eelogmax+0.5
    ENDIF
    LINE (0,0)-(0,Ny%),5
    LINE (0,0)-(Nx%,0),5
     
    IY%=PMAP(-0.4,1)/16+1
    FOR i%=2 TO Nx% STEP 2
    LINE (i%,0.0)-(i%,0.1),5
    IX%=PMAP(i%,0)/8+2
    LOCATE(IY%,IX%)
    PRINT i%
    NEXT I%
    IX%=PMAP(-0.02,0)/8+1
    FOR i%=1 TO Ny% 
       y=i%
    LINE (0.0,y)-(0.2,y),5
    IY%=PMAP(y,1)/16+2
    LOCATE (IY%,IX%)
    PRINT USING "#";y
    NEXT i%
    
    IX%=PMAP(1.16*mtot,0)/8+1
    IY%=PMAP(-0.025,1)/16+2
    LOCATE (IY%,IX%)
    PRINT "M/M0"
END SUB

SUB graphset2(Xmax,Ymax)
     SCREEN 18,2
        __SCREENSET 2,1
 
        WINDOW  (-0.25,1.5)-(Xmax,-Ymax)
        VIEW    (20,20)-(650,450)
       
    Nx%=Xmax-1
    Ny%=Ymax
    LINE (0,-Ymax)-(0,0),5
    LINE (0,0)-(Xmax,0),5
    LINE (0,-Ymax)-(Xmax,-Ymax),5
    
    IY%=PMAP(0.3,1)/16+1
    FOR i%=2 TO Nx% STEP 2
    LINE (i%,0)-(i%,-0.3),5
    LINE (i%,-Ymax)-(i%,-Ymax+0.3),5
    IX%=PMAP(i%,0)/8+2
    LOCATE(IY%,IX%)
    PRINT i%;
    NEXT I%
    IX%=PMAP(-0.1,0)/8+1
    FOR i%=0 TO Ny% STEP 2 
       y=-i%
    LINE (0.0,y)-(0.2,y),5
    IY%=PMAP(y,1)/16+2
    LOCATE (IY%,IX%)
    PRINT USING "###";y;
    NEXT i%
    
    IX%=PMAP(0.9*Xmax,0)/8+1
    IY%=PMAP(0.8,1)/16+2
    LOCATE (IY%,IX%)
    PRINT "M/M0"   
END SUB    