DEFDBL a-z
DECLARE SUB effes (a, m, k1, k2, n, fa, fm)
DECLARE SUB graphset1(Xmax,Ymax)
DECLARE SUB graphset2(Xmax,Ymax)

Dim ns(3),k1s(3),k2s(3),m0s(3),a0s(3),s0s(3)
Dim xxs(5000),ms(5000),aas(5000),ss(5000)
     NdimMax%=5000   '   Ndim%>Xmax/dx
     CLS
     PRINT "P.Hellings: Astrophysics with a PC : GALACTIC STARFORMATION"
     PRINT "-----------------------------------------------"
     PRINT " "
' Adapted by Kiyoshi Kawabata from the program of Capter 11
' on May 25.
     PRINT "Key in 1 for the example  on P.232: n= 1.0,  k1=10,   k2=2.5"
     PRINT "                                   m0=0.15,  s0=0.75, a0=0.1"
     PRINT "Key in 2 for the example1 on P.234: n=1.7,   k1=20,   k2= 25"
     PRINT "                                   m0=0.7,   s0=0.2,  a0=0.1"
     PRINT "Key in 3 for the example2 on P.234: n=1.5,   k1=8,    k2= 15"
     PRINT "                                   m0=0.3,   s0=0.3,  a0=0.4"
     PRINT "Key in 0 for other model"
     INPUT Nkey%
     IF Nkey% > 3 THEN Nkey%=0
     IF Nkey%=0 THEN
     PRINT " "
     PRINT "Input of initial conditions and parameters : "
     INPUT "Initial fraction of molecular clouds : ", m
     INPUT "Initial fraction of atomic gas : ", a
    
     INPUT "Parameter   n : ", n
     INPUT "Parameter k1  : ", k1
     INPUT "Parameter k2  : ", k2
     ELSE
        FOR i%=1 TO 3
        READ m0s(i%),a0s(i%),ns(i%),k1s(i%),k2s(i%)    
        NEXT i%
     ENDIF
        m=m0s(Nkey%): a=a0s(Nkey%):  s = 1 - a - m
        n=ns(Nkey%): k1=k1s(Nkey%): k2=k2s(Nkey%)
        m0=m: a0=a: s0=s
     PRINT " "
     dx = .02

'  heading of main cycle
  i%=0

  CALL graphset1(Xmax,Ymax)
     COLOR 4
     LOCATE (2,5) : PRINT "Star Formation in the Galaxy(Chapter 11)"
     COLOR 6
     LOCATE (4,10): PRINT "Input data:"
     LOCATE (5,10): PRINT USING "m0=#.##, s0= #.##, a0= #.##";m0;s0;a0
     LOCATE (6,10): PRINT USING "n =#.##, k1=##.##, k2=##.##";n;k1;k2
     LOCATE (7,10): PRINT USING "dx=#.###";dx
     COLOR 3
     LOCATE (8,20): PRINT "(1)Phase Diagrams of Star Formation Model"
     COLOR 7
'  prepare for main cycle
   
     x = 0
        xxs(0)=x: aas(0)=a: ms(0)=m: ss(0)=s
        mpre=m: spre=s:  apre=a
 
'  here starts main cycle, computing blocks of 20 iterations
    
     ni% = 1
     DO
            FOR i% = 1 TO 20

'            values at half the step (i+1/2)
                 CALL effes(a, m, k1, k2, n, fa, fm)
                 m1 = m + .5 * dx * fm
                 a1 = a + .5 * dx * fa
                 s1 = 1 - m1 - a1
'            values at full step (i+1)
                 CALL effes(a1, m1, k1, k2, n, fa, fm)
                 m = m + dx * fm
                 a = a + dx * fa
                 s = 1 - m - a
                 x = x + dx

'            show results of newly computed layer on screen
             IF ni% >= NdimMax% THEN GOTO 100
 
             xxs(ni%)=x: aas(ni%)=a: ms(ni%)=m: ss(ni%)=s: Nlay%=ni%
             LOCATE (29,55): PRINT "No. of Iterations=";ni%
          LINE (mpre,spre)-(m,s)
          LINE (mpre+1.2,apre)-(m+1.2,a)
          mpre=m: spre=s: apre=a
          ni% = ni% + 1
           NEXT i%

'       Ask user whether to compute 20 iterations more or not
         LOCATE (28,10)
         COLOR 14
         PRINT "Press S to stop or any other key to continue"
         COLOR 7
          DO
           ch$ = INKEY$
          LOOP WHILE ch$ = ""
     LOOP UNTIL (ch$ = "s") OR (ch$ = "S")
 100:   
    __SLEEP
 
     COLOR 14: 
     LOCATE (29,10): PRINT "Any key to proceed to the next diagrams"
     __SLEEP
     COLOR 7
     CALL graphset2(Xmax,Ymax)
     COLOR 3
     LOCATE (4,20): PRINT "(2)Time Variations of a, m and s"
     COLOR 7
     FOR i%=1 TO Nlay%
        LINE (xxs(i%-1),ss(i%-1))-(xxs(i%),ss(i%))   
        LINE (xxs(i%-1),ms(i%-1)+1.2)-(xxs(i%),ms(i%)+1.2) 
        LINE (xxs(i%-1),aas(i%-1)+2.4)-(xxs(i%),aas(i%)+2.4)
     NEXT i%   
     COLOR 14
     LOCATE (29,5): PRINT "Any key to terminate this job."
     __SLEEP
' Input data for the example on p.232, and examples 1 and 2 on p.234
'           m0    a0   n   k1   k2
      DATA 0.15, 0.1, 1.0, 10,  2.5  ' Example on p.232
      DATA 0.7,  0.1, 1.7, 20, 25    ' Example 1 on p.234
      DATA 0.3,  0.4, 1.5,  8, 15    ' Example 2 on p.234 
END

SUB effes (a, m, k1, k2, n, fa, fm)
'
'  computes the right hand sides of the differential equa-
'  tions for the variables a (atomic fraction) and m (molec-
'  ular fraction)
'  
   fa = 1 - a - m - k1 * m ^ 2 * a
     IF m > 0! THEN
         fm = k1 * m ^ 2 * a + k2 * (a - 1 + m) * m ^ n
     ELSE
         fm = 0!
     END IF

END SUB


SUB graphset1(Xmax,Ymax)
     SCREEN 18,2
        __SCREENSET 1,0
        Xmax=2.5
        Ymax=2.0
        Xoff=Xmax/15.0
        Yoff=Ymax/15.0
        WINDOW  (-Xoff,Ymax)-(Xmax,-Yoff)
        VIEW    (15,15)-(615,415)
       
    Nx%=10
    Ny%=10
 
 '   LINE (0,1)-(0.95*Xmax,1),5
    LINE (0,0)-(1,0),5
    LINE (0,0)-(0,1),5
 
    IX%=PMAP(-0.025,0)/8+1
    FOR i%=1 TO Ny%  
       y=0.1*i%
    LINE (0.0,y)-(0.025,y),5
    IF i% MOD 10 =0 THEN
    IY%=PMAP(y,1)/16+1
    LOCATE (IY%,IX%)
    PRINT USING "#";y;
    ENDIF
    NEXT i%

    IY%=PMAP(-0.05,1)/16+2
 '   IF IY% > 25 THEN IY%=25
    FOR i%=0 TO 10
        x=0.1*i%
    LINE(x,0)-(x,0.025),5
    IF i% MOD 10 =0 THEN
    IX%=PMAP(x,0)/8+2
    LOCATE (IY%,IX%): PRINT USING "#";x
    ENDIF
    NEXT i%
     
    IX%=PMAP(1.05,0)/8+3
    IY%=PMAP(-0.05,1)/16+1
    LOCATE (IY%,IX%)
    PRINT "m"   
    IX%=PMAP(0,0)/8+2
    IY%=PMAP(1.05,1)/16+1
    LOCATE (IY%,IX%)
    PRINT "s"   
    
    
 '   LINE (0,1)-(0.95*Xmax,1),5
    LINE (1.2,0)-(2.2,0),5
    LINE (1.2,0)-(1.2,1),5
 
    IX%=PMAP(1.2-0.025,0)/8+1
    FOR i%=1 TO Ny%  
       y=0.1*i%
    LINE (1.2,y)-(1.2+0.025,y),5
    IF i% MOD 10 =0 THEN
    IY%=PMAP(y,1)/16+1
    LOCATE (IY%,IX%)
    PRINT USING "#";y;
    ENDIF
    NEXT i%

    IY%=PMAP(-0.05,1)/16+2
 '   IF IY% > 25 THEN IY%=25
    FOR i%=0 TO 10
        x=0.1*i%+1.2
    LINE(x,0)-(x,0.025),5
    IF i% MOD 10 =0 THEN
    IX%=PMAP(x,0)/8+2
    LOCATE (IY%,IX%): PRINT USING "#";0.1*i%
    ENDIF
    NEXT i%
     
    IX%=PMAP(2.2,0)/8+5
    IY%=PMAP(-0.05,1)/16+1
    LOCATE (IY%,IX%)
    PRINT "m"   
    IX%=PMAP(1.2,0)/8+2
    IY%=PMAP(1.05,1)/16+1
    LOCATE (IY%,IX%)
    PRINT "a"   
END SUB   

SUB graphset2(Xmax,Ymax)
     SCREEN 18,2
        __SCREENSET 2,1
        Xmax=50
        Ymax=4.0
       
        WINDOW  (-0.5,Ymax)-(Xmax,-0.05)
        VIEW    (15,15)-(615,415)
        Nx%=Xmax/10
    IY%=PMAP(-0.1,1)/16+2    
    FOR i%=0 To Nx%
        x=10*i%
    LINE (x,0)-(x,0.08),5   
    IX%=PMAP(x,0)/8+1
    LOCATE (IY%,IX%): PRINT USING "##";x
    NEXT i%
    IY%=PMAP(-0.5,1)/16
    IX%=PMAP(Xmax/2,0)/8
    LOCATE (IY%,IX%): PRINT "time x"
    
    LINE (0,0)-(Xmax,0),5
    LINE (0,0)-(0,1),5
    
    LINE (0,1.2)-(Xmax,1.2),5
    LINE (0,1.2)-(0,2.2),5
    
    LINE (0,2.4)-(Xmax,2.4),5
    LINE (0,2.4)-(0,3.4),5
    
    IX%=PMAP(3,0)/8
    IY%=PMAP(1,1)/16+1
    LOCATE (IY%,IX%): PRINT "s"
 
    IY%=PMAP(2.4,1)/16+3
    LOCATE (IY%,IX%): PRINT "m"
    
    IY%=PMAP(3.6,1)/16+3
    LOCATE (IY%,IX%): PRINT "a"
    
 END SUB
 
  