DEFDBL a-z
DECLARE SUB effes (r, z, e, fe, a0, dc, kr, kz)
DECLARE SUB graphset1(Xmax,Ymax)
DECLARE SUB graphset2(Xmax,Ymax)

Dim r0s(3),z0s(3), u0s(0), v0s(3), vt00s(3)
Dim rs(30000),thetas(30000)
NdimMax%=30000
CONST pi = 3.1415926536#

CLS
PRINT " P.Hellings: Astrophysics with a PC : INDIVIDUAL STELLAR ORBITS"
PRINT " --------------------------------------------------"
PRINT " "
' Adapted by Kiyoshi Kawabata from theprogram of Chapter 12
' on May 27, 2008
PRINT "Key in 1 for the example  on P.253 and Figs. 12.6a and 12.6b:" 
PRINT "    r0=10.00, z0=0.00, u0=0.00, v0=150.00, vt0=180.00"
PRINT "Key in 2 for Figs. 12.6a and 12.6b on p.257 (Ring Orbits):
PRINT "    r0=10.00, z0=0.00, u0=0.00, v0=180.00, vt0=150.00"
PRINT "Key in 3 for Figs. 12.7 on p.258 (Tube Orbits):
PRINT "    r0=10.00, z0=0.00, u0=0.00, v0=180.00, vt0=150.00"
PRINT "Key in 0 for your own model"

INPUT "Which case would you like to try";Nkey%
  IF Nkey% >4 THEN Nkey%=0
    IF Nkey%=0 THEN
PRINT " "
PRINT " Input of initial conditions and parameters : "
INPUT "Initial conditions :  r(o) : ", r
INPUT "Initial conditions :  z(o) : ", z
INPUT "Initial conditions :  u(o) : ", u
INPUT "Initial conditions :  v(o) : ", v
INPUT "Initial conditions : vt(o) : ", vt0
        rs(0)=r: z0s(0)=z: u0s(0)=u: v0s(0)=v: vt00s(0)=vt0
  ELSE
    FOR i%=1 TO 3
    READ r0s(i%), z0s(i%), u0s(i%), v0s(i%), vt00s(i%)
    NEXT i%
END IF

    r=r0s(Nkey%): z=z0s(Nkey%): u=u0s(Nkey%): v=v0s(Nkey%):
    vt0=vt00s(Nkey%)   
    r0=r:  v0=v
 
    CALL graphset1(Xmax,Ymax)
   
    LOCATE (22,60): PRINT USING "r0 =###.##";r0
    LOCATE (23,60): PRINT USING "v0 =###.##";v0
    LOCATE (24,60): PRINT USING "vt0=###.##";vt0
    LOCATE (30,10)
    COLOR 14
    PRINT "Press S to stop or any other key to continue"
    COLOR 7
' initial galaxy model parameters
dt = .001
e = .99
dc = 11613.5
a0 = 2.8
fe = 1.4292567#

' initialize main cycle
h = r * vt0
past% = 0
n% = 15

t = 0
ni%=0
     
     rs(0)=r: thetas(0)=0
     PSET(r,z)
ni% = 1
          
' here starts main cycle computing blocks of 15 iterations
DO
    FOR i% = 1 TO n%
'    FOR i%=-1000 TO 1000 : For experiments
'     results at half the step (i+1/2)
        r1 = r + .5 * dt * u
        z1 = z + .5 * dt * v
        CALL effes(r, z, e, fe, a0, dc, kr, kz)
        u1 = u + .5 * dt * (kr + h * h / r / r / r)
        v1 = v + .5 * dt * kz

'     results at the full step (i+1)
        r = r + dt * u1
        z = z + dt * v1
        CALL effes(r1, z1, e, fe, a0, dc, kr1, kz1)
        u = u + dt * (kr1 + h * h / r1 / r1 / r1)
        v = v + dt * kz1
        t = t + dt
        LINE -(r,z)
        theta=theta+dt*h/r1^2
                     
        IF Nlay% < Ndimmax% THEN
        rs(ni%)=r: thetas(ni%)=theta  
        Nlay%=ni%
        ENDIF
        LINE -(r,z)
        Niter%=ni%
        COLOR 3
        LOCATE (25,60): PRINT "No. of iter.=";Niter%: COLOR 7
        ni% = ni% + 1
    NEXT i%

' ask user whether to compute 15 iterations more or not
   
    DO
        ch$ = INKEY$
        LOOP WHILE ch$ = ""
    LOOP UNTIL (ch$ = "s") OR (ch$ = "S")
    
    CALL graphset2(Xmax,Ymax)
     COLOR 3
        LOCATE (25,60): PRINT "No. of iter.=";Nlay%: COLOR 7
    PSET(rs(0)/3,0)
    FOR i%=1 TO Nlay%
    r=rs(i%)/3
    theta=thetas(i%)
    x=r*Cos(theta)
    y=r*Sin(theta)
    LINE -(x,y)   
    NEXT i%
  
    COLOR 6
    LOCATE (30,10): PRINT "Any key to terminate this job": COLOR 7
    
    __SLEEP
' Input data for Figs. 12.5a,b, 12.6a,b, and 12.7
    DATA 10.00, 0.00, 0.00, 150.00, 180.00
    DATA 10.00, 0.00, 0.00, 180.00, 150.00
    DATA 10.00, 0.00, 0.00, 121.00, 180.00
END

SUB effes (r, z, e, fe, a0, dc, kr, kz)
'
'  evaluates the right hand sides of the differential 
'  equations of motion for the coordinates r and z. 
'  Both right hand sides are computed in the
'  same cycle applying Simpson's rule for the numerical
'  calculations of a defined integral
'
     k1 = 0
     k2 = 0
     db = fe / 20
     b1 = 0
     b2 = db
     b3 = 2 * db
     fr1 = 0
     fz1 = 0

'   next FOR cycle computes ten pairs of subintervals for 
'   the numerical ntegration with Simpson's rule
     FOR ii% = 1 TO 10
        a2 = 1 / e * SQR((r * SIN(b2)) ^ 2 + (z * TAN(b2)) ^ 2)
        a3 = 1 / e * SQR((r * SIN(b3)) ^ 2 + (z * TAN(b3)) ^ 2)
        fr2 = EXP(-a2 / a0) * (SIN(b2)) ^ 2
        fz2 = EXP(-a2 / a0) * (TAN(b2)) ^ 2
        fr3 = EXP(-a3 / a0) * (SIN(b3)) ^ 2
        fz3 = EXP(-a3 / a0) * (TAN(b3)) ^ 2
        k1 = k1 + db * (fr1 + 4 * fr2 + fr3) / 3
        k2 = k2 + db * (fz1 + 4 * fz2 + fz3) / 3
        b1 = b1 + 2 * db
        b2 = b2 + 2 * db
        b3 = b3 + 2 * db
        fr1 = fr3
        fz1 = fz3
     NEXT ii%

'  multiply the two integrals with the other factors of 
'  the equations of motion
     kr = -4 * pi * SQR(1 - e * e) / e ^ 3 * dc * r * k1
     kz = -4 * pi * SQR(1 - e * e) / e ^ 3 * dc * z * k2
     
END SUB

SUB graphset1(Xmax,Ymax)
' Ocuupation area projected on the galactic plane (cf., Fig. 12.8)    
     SCREEN 18,2
        __SCREENSET 1,0
    
        WINDOW  (3,5)-(14,-4)
        VIEW    (15,15)-(615,415)
    
    LINE (4,0)-(11,0),5
    LINE (4,-4)-(4,4),5
        IY%=PMAP(-0.55,1)/16+1
    FOR i%=5 TO 11
    LINE (i%,0)-(i%,0.1),5
    IX%=PMAP(i%,0)/8+1
    LOCATE (IY%,IX%): PRINT USING "##";i%
    NEXT i%
     
        IX%=PMAP(3.8,0)/8+1
    FOR i%=-4 TO 4  
        IY%=PMAP(i%,1)/16+1
    LINE (4,i%)-(4.1,i%),5    
    LOCATE (IY%,IX%)
    PRINT USING "##";i%
    NEXT i%

    IY%=PMAP(0,1)/16+1
    IX%=PMAP(11.7,0)/8
    LOCATE (IY%,IX%): PRINT "R(kpc)"
    
    IY%=PMAP(4.5,1)/16
    IX%=PMAP(0.0,0)/8
    LOCATE (3,9): PRINT "Z(kpc)"
   
END SUB   


SUB graphset2(Xmax,Ymax)
    SCREEN 18,2
        __SCREENSET 2,1
    
        WINDOW  (-6,6)-(6,-6)
        VIEW    (19,19)-(499,499)
    COLOR 4    
    LOCATE (5,60): PRINT "(see Fig. 12.8)" : COLOR 7
    LINE (-5.5,0)-(5.5,0),5
    LINE (0,-5.5)-(0,5.5),5
    IY%=PMAP(-0.3,1)/16+2
    IX%=PMAP(5.7,0)/8
    LOCATE (IY%,IX%): PRINT "R"
    LOCATE (IY%-2,IX%): PRINT "Theta=0"
    IY%=PMAP(5.5,1)/16+1
    IX%=PMAP(0,0)/8+4
    LOCATE(IY%,IX%): PRINT "Theta=Pi/2"
    IY%=PMAP(-5.5,1)/16+1
    LOCATE (IY%,IX%): PRINT "Theta=3*Pi/2"
    FOR i%=-5 TO 5
    LINE (i%,0)-(i%,0.1),5
    NEXT i%
     
        IX%=PMAP(-0.1,0)/8+1
    FOR i%=-5 TO 5  
       LINE (0,i%)-(0.1,i%),5    
    NEXT i%

   
END SUB   

