DEFDBL a-z
DECLARE SUB graphset(Xmin,Xmax,Ymin,Ymax)
DECLARE SUB DOTS(x1,y1,x2,y2)
Dim ss(4,3),qs(4,3),ks(4,3),Anames$(4,3)
Dim Ncases%(3)

CLS
PRINT "P.Hellings: Astrophysics with a PC : UNIVERSE MODEL"
PRINT "---------------------------------------"
PRINT " "
' Adapted by Kiyoshi Kawabata from the program of Chapter 13
' on May 29, 2008.
' Memos:  sigma0=Omega0/2, q0=(Omega0/2)-Lambda0 (Lambda0=sigma0-q0)
'         k=SGN(3*sigma0-q0-1)

PRINT "Key in 0 for your own model"
PRINT "Key in 1 for Type A1 models(sima0=q0, so that Lambda=0:"
PRINT "Key in 2 for Type A2 models(sigma0=0):"
PRINT "Key in 3 for Type A3 models(sigma0>0, sigma0<>q0):"

INPUT "Which Type of models  would you like to try";Nkey%

IF Nkey% >4 THEN Nkey%=0
IF Nkey%=0 THEN 
PRINT " "
PRINT "Input of the parameters : "
INPUT "sigma(o) : ", s
INPUT "q(o)     : ", q
PRINT " "
    ss(1,0)=s: qs(1,0)=q: ks(1,0)=SGN(3.0*s-q-1): Ncases%(0)=1
    Anames$(1,0)="new"
ELSE
    READ Ncases%(1),Ncases%(2),Ncases%(3)  
    FOR j%=1 TO 3
 '       PRINT "j%=";j%;" Ncases%(j%)=";Ncases%(j%)
    FOR i%=1 TO Ncases%(j%)
    READ ss(i%,j%), qs(i%,j%), Anames$(i%,j%)
 '   PRINT "i%=";i%;" s=";ss(i%,j%);" q=";qs(i%,j%);" Name=";Anames$(i%,j%)
'    PRINT "i%=";i%;" j%=";j%;" s=";ss(i%,j%);" q=";qs(i%,j%)
    NEXT i%
    NEXT j%
END IF
Ncase%=Ncases%(Nkey%)
'PRINT "Ncase%=";Ncase%;" Nkey%=";Nkey%
 '   FOR i%=1 TO Ncase%
 '   PRINT "s=";ss(i%,Nkey%);" q=";qs(i%,Nkey%);"  Name=";Anames$(i%,Nkey%)
'NEXT i%
'__SLEEP
' preparation for drawing a diagram
CALL graphset(Xmin,Xmax,Ymin,Ymax)

FOR Kcase%=1 TO Ncase%
    s=ss(Kcase%,Nkey%): q=qs(Kcase%,Nkey%)
 '   count%=0
 '   xs(count%,era%)=x: ys(count%,era%)=y: zs(count,era%)=z
' this FOR conymputes the past (era% = 0) 
' and the future (era% = 1)
FOR era% = 0 TO 1
    x = 0
    y = 1
    z = 1
'    xs(0,era%)=x: ys(0,era%)=y: zs(0,era%)=z
    ctn% = 1
    PSET(x,y)
'select the time step
    IF era% = 0   THEN
        dx = -.002
 '       LOCATE(25,5) 
 '       PRINT "Computations for the past"
     ELSE
        dx = .002
 '       LOCATE(25,5) 
 '       PRINT "Computations for the future"
     END IF

' display heading of table of results
 '   PRINT " "
 '   PRINT "    x          y         z"
 
    count% = 0
 '   PRINT USING "####.####  ####.####  ####.####"; x; y; z

' main cycle of the iterative procedure
    DO

'     decrease time step if function y is too steep
        IF ABS(z) > 2 THEN dx = .01 * dx / ABS(dx)

'      results at half the step
        x12 = x + .5 * dx
        y12 = y + .5 * dx * z

'      check if scale factor y12 is still positive
        IF y12 > 0 THEN
            z12 = z + .5 * dx * (-s / y / y + (s - q) * y)

'          results for the full step
            x = x + dx
            y = y + dx * z12

'          check if scale factor y1 is still positive
            IF y > 0 THEN
                z = z + dx * (-s / y12 / y12 + (s - q) * y12)
                count% = count% + 1
                LINE -(x,y),Kcase%
          '        LINE -(x,y),2+Kcase%
                IF era%=0 AND x<=Xmin THEN GOTO 100
                IF era%=1 AND (x>=Xmax OR y>= Ymax) THEN GOTO 200
 
           ELSE  'this ELSE is reached when y1 was negative
               IF era% = 0 THEN 
                   LINE -(x-0.3*dx,0),Kcase%
                
                           GOTO 100
               ELSE 
                           GOTO 200
               ENDIF            
 
           END IF

        ELSE   'this ELSE is reached when y12 was negative
            IF era% = 0 THEN
                    GOTO 100
' Model starts from Big Bang
             ELSE
                GOTO 200 
' Model ends in a Collapse
             END IF
 
       END IF
    LOOP UNTIL ctn% = 0

100: NEXT era%
200:    'For legend of the diagram
    X1=0.75*Xmax: X2=X1+1: Y1=0.8*Ymax-6.5/(415-25)*16*Kcase%
    LINE (X1,Y1)-(X2,Y1),2+Kcase%

    IX%=PMAP(X2,0)/8+5: IY%=PMAP(Y1,1)/16+2
    LOCATE (IY%,IX%)
    PRINT USING ": A#-&     &";Nkey%;Anames$(Kcase%,Nkey%)
   
 NEXT Kcase%

LOCATE(28,40)
COLOR 14

PRINT "Press any key to terminate this job"

DO
LOOP WHILE INKEY$ = ""

DATA  4, 4, 4    ' Ncases%(i%)  (i%=0,1,2,3)
'  Type A1 models
DATA 0.0, 0.0, "i  "  ' k=-1,  Lambda=0
DATA 0.3, 0.3, "ii  "  ' k=-1,  Lambda=0
DATA 0.5, 0.5, "iii  "  ' k= 0,  Lambda=0
DATA 1.0, 1.0, "iv  "  ' k= 1,  Lambda=0
'  Type A2 models
DATA 0.0, 0.5,  "v  "  ' k=-1,  Lambda<0
DATA 0.0,-1.5,  "vi-a"  ' k= 1,  Lambda>0
DATA 0.0,-1.0,  "vi-b"  ' k= 0,  Lambda>0
DATA 0.0,-0.75, "vi-c"  ' k=-1,  Lambda>0
'  Type A3 models
DATA 0.3, 0.4,  "vii-a"   ' k=-1,  Lambda<0
DATA 0.6, 0.4,  "vii-b"   ' k= 1,  Lambda>0
DATA 1.5, 1.3125,"vii-c"  ' k=-1,  Lambda>0  For Fig.13.2
DATA 0.12,-0.64,"vii-d"   ' k= 0,  Lambda>0

END

SUB graphset(Xmin,Xmax,Ymin,Ymax)    
    SCREEN 18,2
  __SCREENSET 1,0
    Xmax=10.5: Ymax=6.5: Xmin=-2.5: Ymin=-0.3
    Imin%=Int(Xmin): Imax%=Int(Xmax*0.99) 
    Jmax%=Int(Ymax) 
       WINDOW  (Xmin,Ymax)-(Xmax,Ymin)
       
       VIEW    (25,25)-(615,415)
    
    LINE (Xmin,0)-(Xmax,0),5
    LINE (-1,0)-(-1,Ymax),5
  
  
    IY%=PMAP(-0.5,1)/16+1
    FOR i%=Fix(Xmin) TO Fix(Xmax)
    LINE (i%,0)-(i%,0.1),5
    IX%=PMAP(i%,0)/8+2
    LOCATE (IY%,IX%): PRINT USING "##";i%
    NEXT i%
    
    IX%=PMAP(-1.1,0)/8
    FOR j%=1 TO Jmax% 
    IY%=PMAP(j%,1)/16+2
    LINE (-1,j%)-(-1+0.1,j%),5    
    LOCATE (IY%,IX%)
    PRINT USING "##";j%
    NEXT j%

    IY%=PMAP(-0.2,1)/16
    IX%=PMAP(Xmax,0)/8+2
    LOCATE (IY%,IX%): PRINT "X"
    
    IY%=PMAP(6,1)/16+1
    IX%=PMAP(-0.4,0)/8
    LOCATE (IY%,IX%): PRINT "Y"
    
    CALL DOTS(0,0,0,1)
    CALL DOTS(0,1,-1,1)
 
END SUB   
 
SUB DOTS(x1,y1,x2,y2)
    dx=SGN(x2-x1)*0.05
    dy=SGN(y2-y1)*0.05
    IF dx <> 0.0 THEN
    NX%=INT((x2-x1)/dx+1)
    ELSE 
    NY%=INT((y2-y1)/dy+1)
    ENDIF
'    PRINT "x2-x1="; x2-x1; "  y2-y1=";y2-y1 
    N%=NX%
    IF NY% > NX% THEN N%=NY%
'   PRINT "N%=";N%;"  dx=";dx;"  dy=";dy
    FOR I%=2 TO N%  STEP 2 
    xb=x1+dx*(I%-1)
    yb=y1+dy*(I%-1)
    LINE (xb-dx,yb-dy)-(xb,yb),5
    NEXT I%
END SUB
